# RequiredInterfaces.jl

[![CI Stable](https://github.com/Seelengrab/RequiredInterfaces.jl/actions/workflows/ci.yml/badge.svg?branch=main)](https://github.com/Seelengrab/RequiredInterfaces.jl/actions/workflows/ci.yml)
[![CI Nightly](https://github.com/Seelengrab/RequiredInterfaces.jl/actions/workflows/nightly.yml/badge.svg?branch=main)](https://github.com/Seelengrab/RequiredInterfaces.jl/actions/workflows/nightly.yml)
[![docs-stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://seelengrab.github.io/RequiredInterfaces.jl/stable)
[![docs-dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://seelengrab.github.io/RequiredInterfaces.jl/dev)

RequiredInterfaces.jl is a small package, allowing abstract-type based definition of interface methods, as well as
some methods for checking whether a type that claims to implement an interface, actually implements the required methods.

Please check out the [documentation](https://seelengrab.github.io/RequiredInterfaces.jl/) to learn how you can use RequiredInterfaces.jl to provide basic "implement me" style interfaces in your library.

If you want to learn more about the motivation & philosophy behind this package, check out [this writeup](https://seelengrab.github.io/RequiredInterfaces.jl/dev/interfaces.html) about APIs and their surface in Julia, which is part of the documentation of this package.
